/****************************************************************************
*   COPYRIGHT 2017 All rights reserved
*   Panasonic Industrial Devices Europe GmbH
****************************************************************************/

#ifndef __APPLICATION_H__
#define __APPLICATION_H__

#include <windows.h>
#include <process.h>

#include "types.h"
#include "ble_api.h"

#ifdef DEBUG
#define dprintf(...) do { printf("%s(): ", __func__); printf(__VA_ARGS__); } while(0)
#else
#define dprintf(...)
#endif

int application_init(const char *device_name);
int application_process(void);
int application_handle_keyboard_input(int key);

extern struct ble_api_srv_profile *server;
extern struct ble_api_cli_profile *client;

int uart_init(HANDLE *handle, BOOL flow_control);

#ifndef BD_ADDR_FORMAT
#define BD_ADDR_FORMAT "%02x%02x%02x%02x%02x%02x"
#endif

#ifndef BD_ADDR_ARG
#define BD_ADDR_ARG(x) x[0], x[1], x[2], x[3], x[4], x[5]
#endif


#define RING_SIZE 64
typedef uint32_t ring_pos_t;
struct rb {
	volatile ring_pos_t ring_head;
	volatile ring_pos_t ring_tail;
	volatile uint8_t ring_data[RING_SIZE];
};

void flush_rb(struct rb *rb);
int add_to_rb(struct rb *rb, uint8_t c);
int remove_from_rb(struct rb *rb, uint8_t *c);

#endif