/****************************************************************************
*   COPYRIGHT 2017 All rights reserved
*   Panasonic Industrial Devices Europe GmbH
****************************************************************************/

/**
* @file application.h
*
* @brief Contains type definitions and function declarations of the application.
*/
#ifndef __APPLICATION_H__
#define __APPLICATION_H__

#include "types.h"

int application_init(void);

void uart1_printf(const char *format, ...);

#define aprintf(...)                \
  do {                              \
    uart1_printf(__VA_ARGS__);      \
  } while (0)

extern struct ble_api_srv_profile *server;
extern struct ble_api_cli_profile *client;

static uint8_t device_name[] = "PAN1760A-USB";  
static const uint16_t device_name_len = sizeof(device_name) - 1;

#define RING_SIZE 64
typedef uint32_t ring_pos_t;
struct rb {
  volatile ring_pos_t ring_head;
  volatile ring_pos_t ring_tail;
  volatile uint8_t ring_data[RING_SIZE];
};

void flush_rb(struct rb *rb);
int add_to_rb(struct rb *rb, uint8_t c);
int remove_from_rb(struct rb *rb, uint8_t *c);

#endif
